From 348ec745299d14fdbff1ed2cb33887532229be80 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jan 23 2016 02:45:13 +0000
Subject: [PATCH 270/1001] Clean up github PR widget.


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 035eadd..326fe80 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -62,9 +62,8 @@ def add_user_widgets(session, hub, username, fullname):
     widget = hubs.models.Widget(
         plugin='github_pr', index=7,
         _config=json.dumps({
-             'display_number': 1,
-             'org': 'fedora-infra',
-             'repo': 'fas',
+            'organization': 'fedora-infra',
+            'display_number': 6,
         }))
     hub.widgets.append(widget)
     return hub
diff --git a/hubs/utils.py b/hubs/utils.py
index 0cbff18..f7f9e84 100644
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -1,7 +1,13 @@
+import logging
 from hashlib import sha256
 
+import arrow
+import requests
+
 from six.moves.urllib_parse import urlencode
 
+log = logging.getLogger(__name__)
+
 
 def username2avatar(username, s=312):
     query = urlencode({
@@ -16,3 +22,52 @@ def username2avatar(username, s=312):
 
 def commas(numeric):
     return "{:,}".format(numeric)
+
+def github_repos(token, username):
+    log.info("Finding github repos for %r" % username)
+    tmpl = "https://api.github.com/users/{username}/repos?per_page=100"
+    url = tmpl.format(username=username)
+    auth = dict(access_token=token)
+    for result in _github_results(url, auth):
+        yield result['name']
+
+
+def github_pulls(token, username, repo):
+    log.info("Finding github pull requests for %r %r" % (username, repo))
+    tmpl = "https://api.github.com/repos/{username}/{repo}/" + \
+        "pulls?per_page=100"
+    url = tmpl.format(username=username, repo=repo)
+    auth = dict(access_token=token)
+    for result in _github_results(url, auth):
+        yield dict(
+            user=result['user']['login'],
+            title=result['title'],
+            url=result['html_url'],
+            number=result['number'],
+            assignee=result['assignee'],
+            timestamp=arrow.get(result['created_at']).timestamp,
+        )
+
+
+def _github_results(url, auth):
+    link = dict(next=url)
+    while 'next' in link:
+        response = requests.get(link['next'], params=auth)
+
+        # And.. if we didn't get good results, just bail.
+        if not bool(response):
+            raise IOError("Failed on %r %r" % (link['next'], response))
+
+        results = response.json()
+        for result in results:
+            yield result
+
+        field = response.headers.get('link', None)
+        link = dict()
+        if field:
+            link = dict([
+                (
+                    part.split('; ')[1][5:-1],
+                    part.split('; ')[0][1:-1],
+                ) for part in field.split(', ')
+            ])
diff --git a/hubs/validators.py b/hubs/validators.py
index 8248b29..0dec579 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -9,6 +9,9 @@ def required(session, value):
 def text(session, value):
     return kitchen.text.converters.to_unicode(value)
 
+def integer(session, value):
+    return int(value)
+
 def link(session, value):
     # TODO -- verify that this is actually a link
     return value
@@ -17,6 +20,10 @@ def username(session, value):
     openid = 'http://%s.id.fedoraproject.org/' % value
     return not hubs.models.User.by_openid(session, openid) is None
 
+def github_organization(session, value):
+    # TODO -- implement this.
+    return True
+
 def fmn_context(session, value):
     # TODO get this from the fedmsg config.
     return value in [
diff --git a/hubs/widgets/github_pr.py b/hubs/widgets/github_pr.py
index c2ebfef..6a33091 100644
--- a/hubs/widgets/github_pr.py
+++ b/hubs/widgets/github_pr.py
@@ -1,11 +1,20 @@
+import logging
+
 from hubs.widgets.chrome import panel
 from hubs.hinting import hint
 from hubs.widgets.base import argument
+
 import hubs.validators as validators
+import hubs.utils
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+
 import jinja2
-import requests
 
-chrome = panel("Github: Open Pull Requests")
+log = logging.getLogger(__name__)
+
+chrome = panel("Github: Pull Requests")
 
 template = jinja2.Template("""
   <br />
@@ -14,10 +23,10 @@ template = jinja2.Template("""
       <table class="table-responsive table-condensed">
         <tr>
           <td valign="top" class="panel-heading">
-            <b>#{{ all_pr[i]['num'] }}</b>
+            <b>#{{ pulls[i]['number'] }}</b>
           </td>
           <td width="300px">
-            <b>{{ all_pr[i]['title'] }}</b>
+            <b>{{ pulls[i]['title'] }}</b>
           </td>
         </tr>
       </table>
@@ -25,16 +34,16 @@ template = jinja2.Template("""
         <tr>
           <td width="300px">
             <font size="2">
-              <i>Opened by <a href="https://github.com/{{ all_pr[i]['openedby'] }}" target="_blank">{{ all_pr[i]['openedby'] }}</a></i>
-              {% if all_pr[i]['assignee']|string() == "None" %}
+              <i>Opened by <a href="https://github.com/{{ pulls[i]['user'] }}" target="_blank">{{ pulls[i]['user'] }}</a></i>
+              {% if pulls[i]['assignee']|string() == "None" %}
                 <br /><i>Unclaimed</i>
               {% else %}
-                 <br /><i>Assigned by <a href="https://github.com/{{ all_pr[i]['assignee'] }}" target="_blank">{{ all_pr[i]['assignee'] }}</a></i>
+                 <br /><i>Assigned by <a href="https://github.com/{{ pulls[i]['assignee'] }}" target="_blank">{{ pulls[i]['assignee'] }}</a></i>
               {% endif %}
             </font>
           </td>
           <td>
-             <a href="https://github.com/{{ org }}/{{ repo }}/pulls/{{ all_pr[i]['num'] }}" target="_blank">
+             <a href="{{ pulls[i]['url'] }}" target="_blank">
                <button type="button" class="btn btn-default" aria-label="Left Align">
                  <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
                </button>
@@ -44,42 +53,48 @@ template = jinja2.Template("""
       </table>
     </div>
     {% endfor %}
+    {% if more != 0 %}
     <div class="row">
-      <a href="https://github.com/{{ org }}/{{ repo }}/pulls" target="_blank"><center>All Pull Requests</center></a>
+      <a href="https://github.com/{{ organization }}" target="_blank"><center>and {{ more }} more</center></a>
     </div>
+    {% endif %}
 """)
 
-@argument(name="repo",
+
+@argument(name="display_number",
+          default=6,
+          validator=validators.integer,
+          help="How many pull requests to display at max.")
+@argument(name="organization",
           default=None,
-          validator=validators.repo,
-          help="Repo")
-def data(session, widget, display_number, org, repo):
-  url = '/'.join(['https://api.github.com/repos',org,repo,"pulls"])
-  pr_response = requests.get(url)
-  data = pr_response.json()
-  all_pr = list()
-  for i in range(0,1):
-    pr_details=dict()
-    pr_num=data[i]['number']
-    pr_title=data[i]['title']
-    pr_openedby=data[i]['user']['login']
-    if(data[i]['assignee']!=None):
-      pr_assignee=data[i]['assignee']['login']
-    else:
-      pr_assignee=data[i]['assignee']
-    pr_details['num']=pr_num
-    pr_details['title']=pr_title
-    pr_details['openedby']=pr_openedby
-    pr_details['assignee']=pr_assignee
-    all_pr.append(pr_details)
-  all_pr.reverse()
-  return dict(
-    org=org,
-    repo=repo,
-    all_pr=all_pr,
-    display_number=display_number,
-  )
+          validator=validators.github_organization,
+          help="Github Organization or username")
+def data(session, widget, display_number, organization):
+    log.info("Getting GH prs for %r, (%r)" % (organization, display_number))
+    token = config['github.oauth_token']
+    org = organization
+    repos = hubs.utils.github_repos(token, org)
+    pulls = sum([
+        list(hubs.utils.github_pulls(token, org, repo))
+        for repo in repos
+    ], [])
+    # Reverse-sort by time (newest-first)
+    pulls.sort(lambda a, b: cmp(b['timestamp'], a['timestamp']))
+
+    # Some hints for display
+    display_number = min(display_number, len(pulls))
+    more = len(pulls) - display_number
+    if more < 0:
+        more = 0
+
+    return dict(
+        organization=org,
+        display_number=display_number,
+        more=more,
+        pulls=pulls,
+    )
+
 
 @hint()
 def should_invalidate(message, session, widget):
-  raise NotImplementedError
+    raise NotImplementedError

